MODULE U;

IMPORT T, SYSTEM;

(* ToDo:
- Ptr8* - Ok! tested
- Ptr16* - Ok! tested
- Ptr32* - Ok! tested
- CharIsValid8 - Ok! tested
- CharIsValid16 - Ok! tested
- CharIsValid32 - Ok! tested
- NextChar8pos - Ok! clear
- NextChar16pos - Ok! clear
- IsValid8* - Ok! clear
- IsValid16* - Ok! clear
- IsValid32* - Ok! clear
- U8len* - Ok! clear
- U16len* - Ok! clear
- U32len* - Ok! clear
- U32to8len - Ok! clear
- U32to16len - Ok! clear
- U8to16len - Ok! clear
- U16to8len - Ok! clear
- Char8to32 - Ok! tested
- Char32to8 - Ok! tested
- Char16to32 - Ok! tested
- Char32to16 - Ok! tested
- Char8to16 - Ok! clear
- Char16to8 - Ok! clear
- s8to32* - Ok! clear
- s32to8* - Ok! clear
- s16to32* - Ok! clear
- s32to16* - Ok! clear
- s8to16* - Ok! clear
- s16to8* - Ok! clear *)

PROCEDURE Ptr8*(str: ARRAY OF CHAR): T.Str8;
(** Return pointer to copy of ARRAY OF CHAR *)
VAR
	ptr: T.Str8;
	i: LONGINT;
BEGIN
	NEW(ptr, LEN(str));
	
	FOR i:= 0 TO LEN(str) - 1 DO ptr[i]:= str[i] END;
	
	RETURN ptr;
END Ptr8;

PROCEDURE Ptr16*(str: ARRAY OF T.WCHAR): T.Str16;
(** Return pointer to copy of ARRAY OF WCHAR *)
VAR
	ptr: T.Str16;
	i: LONGINT;
BEGIN
	NEW(ptr, LEN(str));
	
	FOR i:= 0 TO LEN(str) - 1 DO ptr[i]:= str[i] END;
	
	RETURN ptr;
END Ptr16;

PROCEDURE Ptr32*(str: ARRAY OF T.UCHAR): T.Str32;
(** Return pointer to copy of ARRAY OF UCHAR *)
VAR
	ptr: T.Str32;
	i: LONGINT;
BEGIN
	NEW(ptr, LEN(str));
	
	FOR i:= 0 TO LEN(str) - 1 DO ptr[i]:= str[i] END;
	
	RETURN ptr;
END Ptr32;

PROCEDURE CharIsValid8(str: T.Str8; pos: LONGINT): BOOLEAN;
(* Return TRUE if char is valid, FALSE if char is not valid *)
BEGIN
	CASE str[pos] OF
		0X..7FX				: RETURN TRUE
		
		| 0C2X..0DFX	: IF (((pos + 1) < LEN(str^)) &
												(str[pos + 1] >= 080X) &
												(str[pos + 1] <= 0BFX)) THEN RETURN TRUE END
		
		| 0E0X..0EFX	: IF (((pos + 2) < LEN(str^)) &
												((str[pos] # 0E0X) OR (str[pos + 1] >= 0A0X)) &
												(str[pos + 1] >= 080X) &
												(str[pos + 1] <= 0BFX) &
												(str[pos + 2] >= 080X) &
												(str[pos + 2] <= 0BFX) &
					((str[pos] # 0EDX) OR (str[pos + 1] < 0A0X))) THEN RETURN TRUE END
		
		| 0F0X..0F4X	: IF (((pos + 3) < LEN(str^)) &
												((str[pos] # 0F0X) OR (str[pos + 1] >= 090X)) &
												((str[pos] # 0F4X) OR (str[pos + 1] <= 08FX)) &
												(str[pos + 1] >= 080X) &
												(str[pos + 1] <= 0BFX) &
												(str[pos + 2] >= 080X) &
												(str[pos + 2] <= 0BFX) &
												(str[pos + 3] >= 080X) &
												(str[pos + 3] <= 0BFX)) THEN RETURN TRUE END
	ELSE END;
	
	RETURN FALSE
END CharIsValid8;

PROCEDURE CharIsValid16(str: T.Str16; pos: LONGINT): BOOLEAN;
(* Return TRUE if char is valid, FALSE if char is not valid *)
BEGIN
	CASE str[pos] OF
		0..0D7FFH, 0E000H..0FFFFH: RETURN TRUE
		| 0D800H..0DBFFH: IF ((pos + 1) < LEN(str^)) &
													(str[pos + 1] >= 0DC00H) &
													(str[pos + 1] <= 0DFFFH) THEN RETURN TRUE END
	ELSE END;
	
	RETURN FALSE;
END CharIsValid16;

PROCEDURE CharIsValid32(char: T.UCHAR): BOOLEAN;
(* Return TRUE if char is valid, FALSE if char is not valid *)
BEGIN
	IF ((char >= 0) & (char < 0D800H)) OR
					((char > 0DFFFH) & (char <= 10FFFFH)) THEN RETURN TRUE
	ELSE RETURN FALSE END;
END CharIsValid32;

PROCEDURE NextChar8pos(str: T.Str8; VAR i: LONGINT);
BEGIN
	CASE str[i] OF
		0X..7FX				: INC(i)		
		| 0C2X..0DFX	: INC(i, 2)
		| 0E0X..0EFX	: INC(i, 3)
		| 0F0X..0F7X	: INC(i, 4)
	END;
END NextChar8pos;

PROCEDURE NextChar16pos(str: T.Str16; VAR pos: LONGINT);
BEGIN
	IF (str[pos] >= 0D80H) & (str[pos] <= 0DBFFH) THEN INC(pos, 2)
	ELSE INC(pos) END;
END NextChar16pos;

PROCEDURE IsValid8*(str: T.Str8): BOOLEAN;
(** Return TRUE if str is valid (ended by 0X, and all chars are valid) string,
FALSE if str is not valid or = NIL *)
VAR
	i, len: LONGINT;
BEGIN
	IF str = NIL THEN RETURN FALSE END;
	
	i:= 0;
	len:= LEN(str^);
	WHILE (i < len) & (str[i] # 0X) DO
		IF ~CharIsValid8(str, i) THEN RETURN FALSE END;
		
		NextChar8pos(str, i);
	END;
	
	IF i = len THEN RETURN FALSE
	ELSE RETURN TRUE END;
END IsValid8;

PROCEDURE IsValid16*(str: T.Str16): BOOLEAN;
(** Return TRUE if str is valid (ended by 0, and all chars are valid) string,
FALSE if str is not valid or = NIL *)
VAR
	i, len: LONGINT;
BEGIN
	IF str = NIL THEN RETURN FALSE END;
	
	i:= 0;
	len:= LEN(str^);
	WHILE (i < len) & (str[i] # 0) DO
		IF ~CharIsValid16(str, i) THEN RETURN FALSE END;
		
		NextChar16pos(str, i);
	END;
	
	IF i = len THEN RETURN FALSE
	ELSE RETURN TRUE END;
END IsValid16;

PROCEDURE IsValid32*(str: T.Str32): BOOLEAN;
(** Return TRUE if str is valid (ended by 0, and all chars are valid) string,
FALSE if str is not valid or = NIL *)
VAR
	i, len: LONGINT;
BEGIN
	IF str = NIL THEN RETURN FALSE END;
	
	i:= 0;
	len:= LEN(str^);
	WHILE (i < len) & (str[i] # 0) DO
		IF ~CharIsValid32(str[i]) THEN RETURN FALSE END;
		
		INC(i)
	END;
	
	IF i = len THEN RETURN FALSE
	ELSE RETURN TRUE END;
END IsValid32;

PROCEDURE U8len*(str: T.Str8): LONGINT;
(** Return number of unicode characters in utf8 string
up to and include 0X-character. If str is not valid return -1 *)
VAR
	i, count: LONGINT;
BEGIN
	IF ~IsValid8(str) THEN RETURN -1 END;
	
	i:= 0; count:= 0;
	
	WHILE str[i] # 0X DO
		NextChar8pos(str, i);
		INC(count);
	END;
	
	RETURN (count + 1);
END U8len;

PROCEDURE U16len*(str: T.Str16): LONGINT;
(** Return number of unicode characters in utf16 string
up to and include 0X-character. If str is not valid return -1 *)
VAR
	i, count: LONGINT;
BEGIN
	IF ~IsValid16(str) THEN RETURN -1 END;
	
	i:= 0; count:= 0;
	
	WHILE str[i] # 0 DO
		NextChar16pos(str, i);
		INC(count);
	END;
	
	RETURN count + 1;
END U16len;

PROCEDURE U32len*(str: T.Str32): LONGINT;
(** Return number of unicode characters in ucs4 string
up to and include 0X-character. If str is not valid return -1 *)
VAR
	i: LONGINT;
BEGIN
	IF ~IsValid32(str) THEN RETURN -1 END;
	
	i:= 0;
	
	WHILE str[i] # 0 DO INC(i) END;
	
	RETURN (i + 1);
END U32len;

PROCEDURE U32to8len(str: T.Str32): LONGINT;
VAR
	i, len: LONGINT;
BEGIN
	i:= 0; len:= 0;
	
	WHILE str[i] # 0 DO
		CASE str[i] OF
			0..7FH						: INC(len)
			| 80H..07FFH			: INC(len, 2)
			| 800H..0FFFFH		: INC(len, 3)
			| 10000H..10FFFFH	: INC(len, 4)
		END;
		
		INC(i);
	END;
	
	RETURN len + 1;
END U32to8len;

PROCEDURE U32to16len(str: T.Str32): LONGINT;
VAR
	i, len: LONGINT;
BEGIN
	i:= 0; len:= 0;
	
	WHILE str[i] # 0 DO
		IF str[i] < 10000H THEN INC(len)
		ELSE INC(len, 2) END;
		
		INC(i);
	END;
	
	RETURN len + 1;
END U32to16len;

PROCEDURE U8to16len(str: T.Str8): LONGINT;
VAR
	i, len: LONGINT;
BEGIN
	i:= 0; len:= 0;
	
	WHILE str[i] # 0X DO
		IF str[i] < 0F0X THEN INC(len)
		ELSE INC(len, 2) END;
		
		NextChar8pos(str, i);
	END;
	
	RETURN len + 1;
END U8to16len;

PROCEDURE U16to8len(str: T.Str16): LONGINT;
VAR
	i, len: LONGINT;
BEGIN
	i:= 0; len:= 0;
	
	WHILE str[i] # 0 DO
		CASE str[i] OF
			0..7FH													: INC(len)
			| 80H..7FFH											: INC(len, 2)
			| 800H..0D7FFH, 0E000H..0FFFFH	: INC(len, 3)
			| 0D800H..0DBFFH								: INC(len, 4)
		END;
		
		NextChar16pos(str, i);
	END;
	
	RETURN len + 1;
END U16to8len;

PROCEDURE Char8to32(str: T.Str8; pos: LONGINT; VAR out: T.UCHAR);
BEGIN
	out:= 0;
	
	CASE str[pos] OF
		0X..7FX				: out:= ORD(str[pos])		
		| 0C2X..0DFX	: out:= ORD(str[pos]) - 0C0H;
										out:= ASH(out, 6); out:= out + ORD(str[pos + 1]) - 80H;
		| 0E0X..0EFX	: out:= ORD(str[pos]) - 0E0H;
										out:= ASH(out, 6); out:= out + ORD(str[pos + 1]) - 80H;
										out:= ASH(out, 6); out:= out + ORD(str[pos + 2]) - 80H;
		| 0F0X..0F7X	: out:= ORD(str[pos]) - 0F0H;
										out:= ASH(out, 6); out:= out + ORD(str[pos + 1]) - 80H;
										out:= ASH(out, 6); out:= out + ORD(str[pos + 2]) - 80H;
										out:= ASH(out, 6); out:= out + ORD(str[pos + 3]) - 80H;
	END;
END Char8to32;

PROCEDURE Char32to8(in: T.UCHAR; str: T.Str8; pos: LONGINT);
VAR
	t1, t2, t3, t4, i: LONGINT;
	temp: T.UCHAR;
BEGIN
	t2:= 80H; t3:= 80H; t4:= 80H; temp:= in;
	
	CASE in OF
		0..7FH						: str[pos]:= CHR(in)
		
		| 80H..7FFH				: t1:= 0C0H;
				FOR i:= 0 TO 5 DO t2:= t2 + ASH(temp MOD 2, i); temp:= temp DIV 2 END;
				FOR i:= 0 TO 4 DO t1:= t1 + ASH(temp MOD 2, i); temp:= temp DIV 2 END;
				str[pos]:= CHR(t1); str[pos + 1]:= CHR(t2)
		
		| 800H..0FFFFH		: t1:= 0E0H;
				FOR i:= 0 TO 5 DO t3:= t3 + ASH(temp MOD 2, i); temp:= temp DIV 2 END;
				FOR i:= 0 TO 5 DO t2:= t2 + ASH(temp MOD 2, i); temp:= temp DIV 2 END;
				FOR i:= 0 TO 3 DO t1:= t1 + ASH(temp MOD 2, i); temp:= temp DIV 2 END;
				str[pos]:= CHR(t1); str[pos + 1]:= CHR(t2); str[pos + 2]:= CHR(t3)
				
		| 10000H..10FFFFH	: t1:= 0F0H;
				FOR i:= 0 TO 5 DO t4:= t4 + ASH(temp MOD 2, i); temp:= temp DIV 2 END;
				FOR i:= 0 TO 5 DO t3:= t3 + ASH(temp MOD 2, i); temp:= temp DIV 2 END;
				FOR i:= 0 TO 5 DO t2:= t2 + ASH(temp MOD 2, i); temp:= temp DIV 2 END;
				FOR i:= 0 TO 2 DO t1:= t1 + ASH(temp MOD 2, i); temp:= temp DIV 2 END;
				str[pos]:= CHR(t1); str[pos + 1]:= CHR(t2);
				str[pos + 2]:= CHR(t3); str[pos + 3]:= CHR(t4)
	END;
END Char32to8;

PROCEDURE Char16to32(str: T.Str16; pos: LONGINT; VAR out: T.UCHAR);
BEGIN
	out:= 0;
	
	CASE str[pos] OF
		0..0D7FFH, 0E000H..0FFFFH	: out:= str[pos]
		| 0D800H..0DBFFH					: out:= str[pos] - 0D800H;
																out:= ASH(out, 10);
																out:= out + str[pos + 1] - 0DC00H;
																out:= out + 10000H;
	END;
END Char16to32;

PROCEDURE Char32to16(in: T.UCHAR; str: T.Str16; pos: LONGINT);
VAR
	w1, w2, i: LONGINT;
	temp: T.UCHAR;
BEGIN
	CASE in OF
		0..07FFFH: str[pos]:= SHORT(in)
		| 8000H..0FFFFH: str[pos]:= SYSTEM.VAL(SYSTEM.CARD16, SHORT(in - 10000H))
	ELSE
		w1:= 0D800H; w2:= 0DC00H; temp:= in - 10000H;
		FOR i:= 0 TO 9 DO w2:= w2 + ASH(temp MOD 2, i); temp:= temp DIV 2 END;
		FOR i:= 0 TO 9 DO w1:= w1 + ASH(temp MOD 2, i); temp:= temp DIV 2 END;
		str[pos]:= SYSTEM.VAL(SYSTEM.CARD16, SHORT(w1 - 10000H));
		str[pos + 1]:= SYSTEM.VAL(SYSTEM.CARD16, SHORT(w2 - 10000H));
	END;
END Char32to16;

PROCEDURE Char8to16(str8: T.Str8; pos8: LONGINT; str16: T.Str16; pos16: LONGINT);
VAR
	temp: T.UCHAR;
BEGIN
	Char8to32(str8, pos8, temp);
	Char32to16(temp, str16, pos16);
END Char8to16;

PROCEDURE Char16to8(str16: T.Str16; pos16: LONGINT; str8: T.Str8; pos8: LONGINT);
VAR
	temp: T.UCHAR;
BEGIN
	Char16to32(str16, pos16, temp);
	Char32to8(temp, str8, pos8);
END Char16to8;

PROCEDURE s8to32*(str: T.Str8): T.Str32;
(** Return ucs4-string converted from utf8-string
or NIL if input string is not valid *)
VAR
	out: T.Str32;
	len_out, i_in, i_out: LONGINT;
BEGIN
	IF ~IsValid8(str) THEN RETURN NIL END;
	
	len_out:= U8len(str);
	i_in:= 0; i_out:= 0;
	NEW(out, len_out);
	
	WHILE str[i_in] # 0X DO
		Char8to32(str, i_in, out[i_out]);
		
		NextChar8pos(str, i_in);
		INC(i_out);
	END;
	
	out[len_out - 1]:= 0;
	
	RETURN out;
END s8to32;

PROCEDURE s32to8*(str: T.Str32): T.Str8;
(** Return utf8-string converted from ucs4-string
or NIL if input string is not valid *)
VAR
	out: T.Str8;
	len_out, i_in, i_out: LONGINT;
BEGIN
	IF ~IsValid32(str) THEN RETURN NIL END;
	
	len_out:= U32to8len(str);
	i_in:= 0; i_out:= 0;
	NEW(out, len_out);
	
	WHILE str[i_in] # 0 DO
		Char32to8(str[i_in], out, i_out);
		
		INC(i_in);
		NextChar8pos(out, i_out);
	END;
	
	out[len_out - 1]:= 0X;
	
	RETURN out;
END s32to8;

PROCEDURE s16to32*(str: T.Str16): T.Str32;
(** Return ucs4-string converted from utf16-string
or NIL if input string is not valid *)
VAR
	out: T.Str32;
	len_out, i_in, i_out: LONGINT;
BEGIN
	IF ~IsValid16(str) THEN RETURN NIL END;
	
	len_out:= U16len(str);
	i_in:= 0; i_out:= 0;
	NEW(out, len_out);
	
	WHILE str[i_in] # 0 DO
		Char16to32(str, i_in, out[i_out]);
		
		NextChar16pos(str, i_in);
		INC(i_out);
	END;
	
	out[len_out - 1]:= 0;
	
	RETURN out;
END s16to32;

PROCEDURE s32to16*(str: T.Str32): T.Str16;
(** Return utf16-string converted from ucs4-string
or NIL if input string is not valid *)
VAR
	out: T.Str16;
	len_out, i_in, i_out: LONGINT;
BEGIN
	IF ~IsValid32(str) THEN RETURN NIL END;
	
	len_out:= U32to16len(str);
	i_in:= 0; i_out:= 0;
	NEW(out, len_out);
	
	WHILE str[i_in] # 0 DO
		Char32to16(str[i_in], out, i_out);
		
		INC(i_in);
		NextChar16pos(out, i_out);
	END;
	
	out[len_out - 1]:= 0;
	
	RETURN out;
END s32to16;

PROCEDURE s8to16*(str: T.Str8): T.Str16;
(** Return utf16-string converted from utf8-string
or NIL if input string is not valid *)
VAR
	out: T.Str16;
	len_out, i_in, i_out: LONGINT;
BEGIN
	IF ~IsValid8(str) THEN RETURN NIL END;
	
	len_out:= U8to16len(str);
	i_in:= 0; i_out:= 0;
	NEW(out, len_out);
	
	WHILE str[i_in] # 0X DO
		Char8to16(str, i_in, out, i_out);
		
		NextChar8pos(str, i_in);
		NextChar16pos(out, i_out);
	END;
	
	out[len_out - 1]:= 0;
	
	RETURN out;
END s8to16;

PROCEDURE s16to8*(str: T.Str16): T.Str8;
(** Return utf8-string converted from utf16-string
or NIL if input string is not valid *)
VAR
	out: T.Str8;
	len_out, i_in, i_out: LONGINT;
BEGIN
	IF ~IsValid16(str) THEN RETURN NIL END;
	
	len_out:= U16to8len(str);
	i_in:= 0; i_out:= 0;
	NEW(out, len_out);
	
	WHILE str[i_in] # 0 DO
		Char16to8(str, i_in, out, i_out);
		
		NextChar16pos(str, i_in);
		NextChar8pos(out, i_out);
	END;
	
	out[len_out - 1]:= 0X;
	
	RETURN out;
END s16to8;

END U.